## enblend-enfuse 4.1.2+dfsg

=== CMakeLists.txt ===
# This file is part of enblend/enfuse.
# Licence details can be found in the file COPYING.
#
# Copyright(c) 2009-2010, Kornel Benko <Kornel.Benko@berlin.de>
#                  , Ryan Sleevi <ryan+hugin@sleevi.com>
#                  , Harry van der Wolf <hvdwolf@gmail.com>
# Original file from lyx-project, heavily modified
#
cmake_minimum_required(VERSION 2.4)

if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 OLD)
  cmake_policy(SET CMP0005 OLD)
  cmake_minimum_required(VERSION 2.6)
endif(COMMAND cmake_policy)

set(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS true)

project(enblend)
IF(NOT MSVC)
  SET(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel" FORCE)
ENDIF(NOT MSVC)
# where to look first for cmake modules, before ${CMAKE_ROOT}/Modules/
# is checked
# For now, reuse the hugin modules directory
#
# Try to find ...
set(CMAKE_MODULE_PATH) # overwrite cache
find_file(CMAKE_MODULE_PATH CMakeModules
  "${CMAKE_SOURCE_DIR}"
  "${CMAKE_SOURCE_DIR}/../hugin"
  "${CMAKE_SOURCE_DIR}/../hugin-trunk"
  "${CMAKE_SOURCE_DIR}/../../hugin/hugin"
  "${CMAKE_SOURCE_DIR}/../../hugin/trunk"
  "$ENV{HOME}/hugin")
message(STATUS "found hugin modules directory in ${CMAKE_MODULE_PATH}")

set(ARCH_TRIPLET)
if(UNIX)
  FIND_PROGRAM(DPKG_ARCHITECTURE_EXECUTABLE dpkg-architecture)
  if(DPKG_ARCHITECTURE_EXECUTABLE)
    EXECUTE_PROCESS(COMMAND dpkg-architecture -qDEB_HOST_MULTIARCH
      OUTPUT_VARIABLE ARCH_TRIPLET
      ERROR_VARIABLE ERROR_ARCH_TRIPLET
      OUTPUT_STRIP_TRAILING_WHITESPACE)
  endif()
endif()
if(ARCH_TRIPLET)
  set(SYSTEM_LIB_DIRS /usr/lib /usr/lib/${ARCH_TRIPLET} /usr/local/lib)
else()
  set(SYSTEM_LIB_DIRS /usr/lib /usr/local/lib)
endif()

include(HuginMacros)
include(FindLibraryForCPU)

set(EXECUTABLE_OUTPUT_PATH  ${CMAKE_BINARY_DIR}/bin)

# Regenerate when calling make
set(CMAKE_SUPPRESS_REGENERATION FALSE)
set(VERSION_INFO "CMake Build")

# Try to get the package version from file
set(TOP_SRC_DIR ${CMAKE_SOURCE_DIR})
file(STRINGS "${TOP_SRC_DIR}/VERSION" _version_lines)
foreach(_v_l ${_version_lines})
  if(_v_l MATCHES "^\([0-9]+\)\\.\([0-9]+\)\(.*\)")
    set(ENBLEND_MAJOR_VERSION ${CMAKE_MATCH_1})
    set(ENBLEND_MINOR_VERSION ${CMAKE_MATCH_2})
    set(_tmp ${CMAKE_MATCH_3})
    if(_tmp MATCHES "^\\.\([0-9]+\)\(.*\)")
      set(ENBLEND_PATCH_VERSION ${CMAKE_MATCH_1})
      set(_tmp ${CMAKE_MATCH_2})
    else()
      set(ENBLEND_PATCH_VERSION "0")
    endif()
    set(PACKAGE_VERSION_STRING ${_v_l})
    break()
  endif()
endforeach(_v_l)

message(STATUS "Extracted enblend version = ${ENBLEND_MAJOR_VERSION}.${ENBLEND_MINOR_VERSION}.${ENBLEND_PATCH_VERSION}")

# For Win32 builds, assume that all of the libraries are located
# one directory above the current CMakeLists directory
IF(WIN32)
  STRING(REGEX REPLACE "(.*)/[^/]+$" "\\1" work "${CMAKE_SOURCE_DIR}")
  # create the cache entry
  SET(SOURCE_BASE_DIR ${work} CACHE FILEPATH "parent dir of hugin source root")

  LIST(APPEND CMAKE_PREFIX_PATH ${SOURCE_BASE_DIR})
ENDIF(WIN32)

# First include so it picks up(our) config.h
INCLUDE_DIRECTORIES(${CMAKE_BINARY_DIR})

SET(library_type STATIC)
set(common_libs)
IF(WIN32)
# we are using static vigra lib on Windows
ADD_DEFINITIONS(-DVIGRA_STATIC_LIB)
ENDIF(WIN32)

# Configurable options
OPTION(ENABLE_OPENMP "OpenMP Support" OFF)
OPTION(ENABLE_IMAGECACHE "Image Cache Support" ON)
OPTION(ENABLE_GPU "GPU Acceleration Support" OFF)
OPTION(DOC "Create Documentation" OFF)
OPTION(NOSPLIT "Do not split html-documents" OFF)
OPTION(A4 "Use A4 for pdf-doc's" ON)

IF(NOT CMAKE_CL_64)
  OPTION(ENABLE_SSE2 "SSE2 Support(Release builds only)" OFF)
ELSE(NOT CMAKE_CL_64)
  SET(ENABLE_SSE2 OFF CACHE INTERNAL "")
ENDIF(NOT CMAKE_CL_64)
IF(NOT WIN32)
  OPTION(ENABLE_DMALLOC "Use the dmalloc debugging package" OFF)
  OPTION(ENABLE_DMALLOC_FUNC_CHECK "Enable dmalloc function checking" OFF)
ELSE(NOT WIN32)
  SET(ENABLE_DMALLOC OFF CACHE INTERNAL "")
  SET(ENABLE_DMALLOC_FUNC_CHECK OFF CACHE INTERNAL "")
ENDIF(NOT WIN32)

# Compiler specific tweaks and optimizations
IF(CMAKE_COMPILER_IS_GNUCXX)
  SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O3 -ffast-math -DNDEBUG -Wall")
  IF(APPLE AND CMAKE_MAJOR_VERSION EQUAL 2 AND CMAKE_MINOR_VERSION LESS 5)
    ## Add needed Compiler and Linker flags for OSX
    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -flat_namespace -undefined suppress")
    SET(CMAKE_CXX_FLAGS "{$CMAKE_CXX_FLAGS} -flat_namespace -undefined suppress")
    SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -flat_namespace -undefined suppress")
    SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -flat_namespace -undefined suppress")
    SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -flat_namespace -undefined suppress")
  ENDIF(APPLE AND CMAKE_MAJOR_VERSION EQUAL 2 AND CMAKE_MINOR_VERSION LESS 5)
ELSEIF(WIN32)
  IF(MSVC)
    # Quiet some compiler noise
    ADD_DEFINITIONS(-D_CRT_SECURE_NO_DEPRECATE)
    ADD_DEFINITIONS(-D_SCL_SECURE_NO_WARNINGS)
    ADD_DEFINITIONS(-D_CRT_NONSTDC_NO_DEPRECATE)

    # Due to the number of templates and the added overhead in .obj files from 64-bit builds
    # add /bigobj support
    # details: http://msdn.microsoft.com/en-us/library/ms173499.aspx
    IF(CMAKE_CL_64)
      SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /bigobj")
      SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /bigobj")
    ENDIF(CMAKE_CL_64)

    # compile everything for the static C runtime
    FOREACH(TYPE C CXX)
      # makefiles use blank configuration
      FOREACH(CFG "_DEBUG" "_MINSIZEREL" "_RELEASE" "_RELWITHDEBINFO")
	#MESSAGE("Replacing CMAKE_${TYPE}_FLAGS${CFG}: ${CMAKE_${TYPE}_FLAGS${CFG}}")
	SET(NEW_FLAGS "${CMAKE_${TYPE}_FLAGS${CFG}}")
	# fix up static libc flags
	STRING(REPLACE "/MD" "/MT" NEW_FLAGS "${NEW_FLAGS}")
	# *FORCE* to override whats already placed into the cache
	SET(CMAKE_${TYPE}_FLAGS${CFG} "${NEW_FLAGS}" CACHE STRING
	  "CMAKE_${TYPE}_FLAGS${CFG} (overwritten to ensure static build)" FORCE)
	#MESSAGE("New       CMAKE_${TYPE}_FLAGS${CFG}: ${CMAKE_${TYPE}_FLAGS${CFG}}")
      ENDFOREACH(CFG)
    ENDFOREACH(TYPE)
    # link only with the static C runtime !! THIS IS A MUST !!
    SET(NEW_FLAGS "${CMAKE_EXE_LINKER_FLAGS}")
    # ensure that the flags are not duplicated on subsequent runs
    STRING(REPLACE " /NODEFAULTLIB:\"MSVCRT.lib\" /NODEFAULTLIB:\"MSVCRTd.lib\" /LTCG /LARGEADDRESSAWARE" "" NEW_FLAGS "${NEW_FLAGS}")
    # note that flag names (NODEFAULTLIB) etc.) are case sensitive
    SET( CMAKE_EXE_LINKER_FLAGS
      "${NEW_FLAGS} /NODEFAULTLIB:\"MSVCRT.lib\" /NODEFAULTLIB:\"MSVCRTd.lib\" /LTCG /LARGEADDRESSAWARE"
      CACHE STRING "for MSVC" FORCE
      )

    # Maximize speed
    STRING(REPLACE " /O2 " " /Ox /GL " CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE}")
    STRING(REPLACE " /O2 " " /Ox /GL " CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO}")

    SET(CMAKE_CXX_FLAGS_MINSIZEREL "${CMAKE_CXX_FLAGS_MINSIZEREL} /GL")
  ENDIF(MSVC)
ENDIF(CMAKE_COMPILER_IS_GNUCXX)

# Required Libraries first
FIND_PACKAGE(LCMS2 REQUIRED)
FIND_PACKAGE(TIFF REQUIRED)
FIND_PACKAGE(Perl REQUIRED)
# this one is needed in doc. (Especially the program "convert")
FIND_PACKAGE(ImageMagick REQUIRED)
FIND_PACKAGE(GSL REQUIRED)
include_directories(${GSL_INCLUDE_DIR})
LIST(APPEND common_libs ${LCMS2_LIBRARIES} ${TIFF_LIBRARIES} ${GSL_LIBRARIES})
include_directories(${TIFF_INCLUDE_DIR} ${LCMS2_INCLUDE_DIR})

# Platform specifics required libraries
IF(WIN32)
  SET(Boost_USE_STATIC_LIBS ON)
  # path for getopt library
  INCLUDE_DIRECTORIES(${TOP_SRC_DIR}/src/win32helpers)
ENDIF(WIN32)

# Boost headers are required, but filesystem is optional
if(WIN32)
  IF( NOT Boost_root_suffix )
    SET( Boost_root_suffix _1_51_0 CACHE STRING "suffix of boost root dir." FORCE )
  ENDIF( NOT Boost_root_suffix )
  SET(Boost_USE_STATIC_LIBS ON)
  if (NOT BOOST_ROOT AND NOT $ENV{BOOST_ROOT} STREQUAL "") 
    set(BOOST_ROOT $ENV{BOOST_ROOT}) 
  else(NOT BOOST_ROOT AND NOT $ENV{BOOST_ROOT} STREQUAL "") 
    set(BOOST_ROOT ${SOURCE_BASE_DIR}/boost${Boost_root_suffix}) 
  endif(NOT BOOST_ROOT AND NOT $ENV{BOOST_ROOT} STREQUAL "") 
endif()

find_package(Boost COMPONENTS filesystem system)

set(Boost_filesystem_FOUND ${Boost_FILESYSTEM_FOUND})
set(Boost_system_FOUND ${Boost_SYSTEM_FOUND})
message(STATUS "Boost_LIBRARIES = ${Boost_LIBRARIES}")

IF(Boost_filesystem_FOUND)
  ADD_DEFINITIONS(-DHAVE_BOOST_FILESYSTEM)
ELSE(Boost_filesystem_FOUND)
  MESSAGE(STATUS "Boost filesystem library found:     ${Boost_filesystem_FOUND}")
  MESSAGE(STATUS "Boost system library found:         ${Boost_system_FOUND}")
  MESSAGE(STATUS "Disabling Boost filesystem support")
ENDIF(Boost_filesystem_FOUND)

LIST(APPEND common_libs ${Boost_LIBRARIES})
link_directories(${Boost_LIBRARY_DIRS})

IF(NOT MSVC)
  # MSVC supports auto-linking and will always choose the appropriate
  # library for the config. Use explicit specifiers for the other platforms
  LIST(APPEND common_libs ${Boost_LIBRARIES})
ENDIF(NOT MSVC)

include_directories(${Boost_INCLUDE_DIR})

# Optional Libraries
FIND_PACKAGE(ZLIB)
FIND_PACKAGE(JPEG)
FIND_PACKAGE(PNG)
FIND_PACKAGE(OpenEXR)
FIND_PACKAGE(Threads)

# VIGRA uses Has* pre-processor definitions for config.h
ADD_DEFINITIONS(-DHasTIFF)
FIND_PACKAGE(VIGRA REQUIRED)
include_directories(${VIGRA_INCLUDE_DIR})
list(APPEND common_libs ${VIGRA_LIBRARIES})

IF(ZLIB_FOUND)
  LIST(APPEND common_libs ${ZLIB_LIBRARIES})
  include_directories(${ZLIB_INCLUDE_DIR})
ELSEIF(WIN32)
  IF(PNG_FOUND)
    MESSAGE(STATUS "Disabling support for PNG due to lack of zlib")
    SET(PNG_FOUND 0)
  ENDIF(PNG_FOUND)
ENDIF(ZLIB_FOUND)

IF(JPEG_FOUND)
  ADD_DEFINITIONS(-DHasJPEG)
  list(APPEND common_libs ${JPEG_LIBRARIES})
  include_directories(${JPEG_INCLUDE_DIR})
ELSE(JPEG_FOUND)
  MESSAGE(STATUS "Compiling without support for JPEG files")
ENDIF(JPEG_FOUND)

IF(PNG_FOUND)
  ADD_DEFINITIONS(-DHasPNG)
  list(APPEND common_libs ${PNG_LIBRARIES})
  include_directories(${PNG_INCLUDE_DIR})
ELSE(PNG_FOUND)
  MESSAGE(STATUS "Compiling without support for PNG files")
ENDIF(PNG_FOUND)

IF(OPENEXR_FOUND)
  ADD_DEFINITIONS(-DHasEXR)
  list(APPEND common_libs ${OPENEXR_LIBRARIES})
  include_directories(${OPENEXR_INCLUDE_DIR})
ELSE(OPENEXR_FOUND)
  MESSAGE(STATUS "OpenEXR support disabled")
ENDIF(OPENEXR_FOUND)

# Now that packages are / are not detected, handle config options

IF(ENABLE_OPENMP)
  FIND_PACKAGE(OpenMP REQUIRED)
  add_definitions(${OpenMP_CXX_FLAGS})
ENDIF(ENABLE_OPENMP)

IF(ENABLE_IMAGECACHE AND ENABLE_OPENMP)
  MESSAGE(STATUS "image cache and OpenMP support are mutually exclusive. only configure like this if you want to develop a reentrant image cache")
  LIST(APPEND WARNINGS "WARNING: Image cache and OpenMP are both enabled!  You are a developer, aren't you?")
ENDIF(ENABLE_IMAGECACHE AND ENABLE_OPENMP)

IF(ENABLE_IMAGECACHE)
  set(CACHE_IMAGES 1)
ENDIF(ENABLE_IMAGECACHE)

IF(ENABLE_GPU)
  IF(WIN32)
    IF(NOT GLUT_ROOT_PATH)
      SET(GLUT_ROOT_PATH ${SOURCE_BASE_DIR}/glut)
    ENDIF(NOT GLUT_ROOT_PATH)
  ENDIF(WIN32)
  FIND_PACKAGE(GLUT REQUIRED)
  FIND_PACKAGE(GLEW REQUIRED)

  FIND_PACKAGE(OpenGL)
  IF(OPENGL_FOUND)
    if(APPLE)
            ADD_DEFINITIONS(-DHAVE_APPLE_OPENGL_FRAMEWORK)
            include_directories(${OPENGL_INCLUDE_DIR}})
    endif(APPLE)
    LIST(APPEND common_libs ${OPENGL_LIBRARIES})
  ENDIF(OPENGL_FOUND)


  ADD_DEFINITIONS(-DHAVE_LIBGLEW)
  include_directories(${GLEW_INCLUDE_DIR} ${GLUT_INCLUDE_DIR})
  LIST(APPEND common_libs ${GLEW_LIBRARIES} ${GLUT_LIBRARIES})
ENDIF(ENABLE_GPU)

IF(ENABLE_SSE2)
  IF(CMAKE_COMPILER_IS_GNUCXX)
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -msse2 -mtune=pentium4")
  ELSEIF(MSVC)
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} /arch:SSE2")
  ENDIF(CMAKE_COMPILER_IS_GNUCXX)
ENDIF(ENABLE_SSE2)

IF(ENABLE_DMALLOC)
  ADD_DEFINITIONS(-DDMALLOC)
  IF(ENABLE_DMALLOC_FUNC_CHECK)
    ADD_DEFINITIONS(-DDMALLOC_FUNC_CHECK)
  ENDIF(ENABLE_DMALLOC_FUNC_CHECK)

=== doc/CMakeLists.txt ===
# This file is part of enblend.
# Licence details can be found in the file COPYING.
#
# Copyright (c) 2009-2012, Kornel Benko <Kornel.Benko@berlin.de>
#

include(GetPrerequisites)	# get function gp_append_unique()
IF(WIN32)
set(DocumentsDirectory "doc")
ELSE(WIN32)
set(DocumentsDirectory "doc/enblend")
ENDIF(WIN32)

include(${TOP_SRC_DIR}/doc/macros.cmake)
set(main_texi_list enblend enfuse)

set(_docs)
set(_enblend_Bases auxmac.texi auxmac.tex
    fdl.texi
    mask-template-characters.texi
    helpful-programs.texi
    seam-generators.texi
    color-profiles.texi
    tuning-memory-usage.texi
    understanding-masks.texi
    workflow.texi filespec.texi
    external-masks.texi
    bug-reports.texi authors.texi
    photographic-workflow.fig
    external-mask-workflow.fig
    seam-line-visualization.tif
    default.css)

set(_enfuse_Bases auxmac.texi auxmac.tex
    fdl.texi
    mask-template-characters.texi
    helpful-programs.texi
    color-profiles.texi
    tuning-memory-usage.texi
    understanding-masks.texi
    workflow.texi filespec.texi
    external-masks.texi
    bug-reports.texi authors.texi
    config-edge.gp config.gp
    entropy-cutoff.gp.in
    exposure-cutoff.gp.in
    entropy.gp.in gaussian.gp.in
    laplacian-of-gaussian.gp.in
    sharp-edge.gp.in sharp-edge.data
    smooth-edge.gp.in smooth-edge.data
    local-analysis-window.fig
    photographic-workflow.fig
    focus-stack-decision-tree.fig
    external-mask-workflow.fig
    default.css)

set(_enblend_TEXINFOS)
foreach(_e ${_enblend_Bases})
  list(APPEND _enblend_TEXINFOS "${TOP_SRC_DIR}/doc/${_e}")
endforeach(_e)

set(_enfuse_TEXINFOS)
foreach(_e ${_enfuse_Bases})
  list(APPEND _enfuse_TEXINFOS "${TOP_SRC_DIR}/doc/${_e}")
endforeach(_e)

set(_enblendenfuse_fig_images)
set(_enblendenfuse_tif_images)
set(_enblendenfuse_gp_images)

foreach(_cmd ${main_texi_list} )
  doc_create_selection(_${_cmd}_Bases "fig" _${_cmd}_fig_images)
  doc_create_selection(_${_cmd}_Bases "tif" _${_cmd}_tif_images)
  doc_create_selection(_${_cmd}_Bases "gp\\\\.in" _${_cmd}_gp_images)
  set(_${_cmd}_images ${_${_cmd}_fig_images} ${_${_cmd}_tif_images} ${_${_cmd}_gp_images})
  foreach(_i ${_${_cmd}_fig_images})
    gp_append_unique(_enblendenfuse_fig_images ${_i})
  endforeach(_i)
  foreach(_i ${_${_cmd}_tif_images})
    gp_append_unique(_enblendenfuse_tif_images ${_i})
  endforeach(_i)
  foreach(_i ${_${_cmd}_gp_images})
    gp_append_unique(_enblendenfuse_gp_images ${_i})
  endforeach(_i)
endforeach(_cmd)

project(doc0)

set(_helpfiles)

#create <build>/config.h.texi
doc_create_configh_texi(_helpfiles config-h.texi)

# create <build>/vers*.texi
foreach(_cmd ${main_texi_list})
  #message(STATUS "doc_verscopy_file vers${_cmd}.texi")
  doc_verscopy_file(_helpfiles "vers${_cmd}.texi")
endforeach(_cmd)

# create <build>/vars*.texi
foreach(_cmd ${main_texi_list})
  #message(STATUS "doc_varscreate_file ${_cmd}")
  doc_varscreate_file(_helpfiles ${_cmd})
endforeach(_cmd)

# %.txt: %.fig
foreach(_fig ${_enblendenfuse_fig_images})
  #message(STATUS "doc_create_txt_from_fig ${_tif}")
  doc_create_txt_from_fig(_helpfiles ${_fig})
endforeach(_fig)

# %.gif: %.tif
# %.png: %.tif
# %.eps: %.tif
foreach(_tif ${_enblendenfuse_tif_images})
  #message(STATUS "doc_create_tif_images ${_tif}")
  doc_create_tif_images(_helpfiles ${_tif})
endforeach(_tif)

# <source>/%.gp.in: <build>/%.gp
set(srcdir "${TOP_SRC_DIR}/doc")
set(RASTER_DIR "${CMAKE_CURRENT_BINARY_DIR}")
foreach(_gp ${_enblendenfuse_gp_images})
  message(STATUS "Handling ${_gp}.gp.in")
  # (@srcdir@ and @RASTER_DIR@) will be substituted in *.gp.in
  doc_create_gp_in_files(_helpfiles ${_gp})
endforeach()

#message(STATUS "_helpfiles = " ${_helpfiles})
add_custom_target(doc0 DEPENDS ${_helpfiles})

project(doc1)

# search for gnuplot and
# generate images (.txt, .pdf .eps and .png)
find_package(Gnuplot)
set(_depend_gp)
if (NOT DOC OR NOT GNUPLOT_FOUND)
  # there is no gnuplot command, so simply copy the needed files
  file(GLOB _copy_files RELATIVE "${TOP_SRC_DIR}/doc"
    "${TOP_SRC_DIR}/doc/*.txt"
    "${TOP_SRC_DIR}/doc/*.eps"
    "${TOP_SRC_DIR}/doc/*.png"
    "${TOP_SRC_DIR}/doc/*.pdf")
  foreach(_cf ${_copy_files})
    if(NOT ${_cf} MATCHES "en(blend|fuse)") # This is done below
      doc_copybin(_depend_gp "${_cf}")
      list(APPEND _docs "${_cf}")
    endif()
  endforeach(_cf)
else()
  #
  foreach(_gp ${_enblendenfuse_gp_images})
    doc_create_gp_images(_depend_gp ${_gp})
    list(APPEND _docs ${_created})
  endforeach(_gp)
endif()

add_custom_target(doc1 DEPENDS doc0 ${_depend_gp})
project(doc2)

# Search for fig2dev and convert some images
find_program(FIG2DEV_EXE fig2dev)
if (${FIG2DEV_EXE} MATCHES "-NOTFOUND")
  # here the creation of html and pdf will be disabled, because .gif-prerequisites are not found
  # Automake uses here sed and the like
  set(DOC3:BOOL "FALSE")
else()
  #message(STATUS "_enblendenfuse_fig_images =  ${_enblendenfuse_fig_images}")
  foreach(_img ${_enblendenfuse_fig_images})
    foreach(_ext eps gif pdf png)
      doc_create_fig2dev(_depend_gp ${_img} ${_ext})
      list(APPEND _docs ${_img}.${_ext})
    endforeach(_ext)
    if(NOSPLIT)
      install(FILES ${_img}.png DESTINATION ${DocumentsDirectory})
    endif(NOSPLIT)
  endforeach(_img)
  set(DOC3:BOOL ${DOC})
endif()
add_custom_target(doc2 DEPENDS doc1 ${_depend_gp})

project(doc3)
# Search for makeinfo command and
# generate info and pdf for enblend + enfuse
find_program(MAKEINFO_EXE "makeinfo")
if (DOC3:BOOL)
  if ( NOT ${MAKEINFO_EXE} MATCHES "-NOTFOUND")
    # Check for sufficient version, should be >= 4.11
    EXECUTE_PROCESS(COMMAND ${MAKEINFO_EXE} "--version" OUTPUT_VARIABLE _makeinfo_version OUTPUT_STRIP_TRAILING_WHITESPACE)
    foreach(_v_l ${_makeinfo_version})
      #message(STATUS "_v_l = ${_v_l}")
      if(_v_l MATCHES "\\(GNU texinfo\\) *\([0-9]+\)\\.\([0-9]+\)")
	set(MAKEINFO_MAJOR ${CMAKE_MATCH_1})
	set(MAKEINFO_MINOR1 "00000${CMAKE_MATCH_2}")
	if(MAKEINFO_MINOR1 MATCHES "^[0]+\([0-9][0-9][0-9][0-9]\)\$")
	  set(MAKEINFO_MINOR ${CMAKE_MATCH_1})
	endif()
	set(MAKEINFO_VERSION "${MAKEINFO_MAJOR}.${MAKEINFO_MINOR}")
      endif()
    endforeach()
    string(COMPARE GREATER "${MAKEINFO_VERSION}" "4.0010" DOC3:BOOL)
    #message(STATUS "MAKEINFO_VERSION = ${MAKEINFO_VERSION}")
    if (NOT DOC3:BOOL)
      message(STATUS "Sorry, but you need makeinfo version >= 4.11")
    endif()
  endif()
endif()

find_program(TEXI2DVI_EXE "texi2dvi")
if(${EXTRATEXI2DVIFLAGS} MATCHES "^\\@")
  set(TEXI2DVIFLAGS "--command=${EXTRATEXI2DVIFLAGS}")
  message(STATUS "EXTRATEXI2DVIFLAGS = ${EXTRATEXI2DVIFLAGS}")
  message(STATUS "Setting TEXI2DVIFLAGS to ${TEXI2DVIFLAGS}")
else()
  set(TEXI2DVIFLAGS)
  message(STATUS "Resetting TEXI2DVIFLAGS")
endif()

set(_auxdepends)

FILE(GLOB tmp_texi RELATIVE "${TOP_SRC_DIR}/doc" "${TOP_SRC_DIR}/doc/*.tex*")
foreach(_cmd ${main_texi_list})
  # These are already created with doc_varscreate_file()
  list(REMOVE_ITEM tmp_texi vars${_cmd}.texi)
endforeach()

foreach(_f ${tmp_texi})
  if (NOT ${_f} MATCHES "vers.*")
    add_custom_command(
      OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/${_f}"
      COMMAND ${CMAKE_COMMAND} -E copy "${TOP_SRC_DIR}/doc/${_f}" "${CMAKE_CURRENT_BINARY_DIR}/${_f}"
      DEPENDS "${TOP_SRC_DIR}/doc/${_f}"
      )
    list(APPEND _auxdepends "${CMAKE_CURRENT_BINARY_DIR}/${_f}")
  endif()
endforeach()

foreach (_cmd ${main_texi_list})
  set(_created "${CMAKE_CURRENT_BINARY_DIR}/${_cmd}")
  if (NOT DOC3:BOOL OR ${MAKEINFO_EXE} MATCHES "-NOTFOUND" OR ${TEXI2DVI_EXE} MATCHES "-NOTFOUND")
    # there is no makeinfo or no texi2dvi command,
    # this implies insufficient latex installation.
    # Therefore simply copy the data from source tree.
    foreach(_ext "info")
      doc_copybin(_depend_gp "${_cmd}.${_ext}")
      list(APPEND _docs "${_cmd}.${_ext}" "${_created}.${_ext}")
    endforeach()
    #
    # Disabled, because not part of repo.
    # They would have only been created with "make pdf" or "make html" in source doc directory
    # under automake
    if (EXISTS "${TOP_SRC_DIR}/doc/${_cmd}.pdf" AND NOT IS_DIRECTORY "${TOP_SRC_DIR}/doc/${_cmd}.pdf")
      copybin(_depend_gp "${_cmd}.pdf")
      list(APPEND _docs "${_cmd}.pdf" "${_created}.pdf")
    else()
      message(STATUS "Sorry, but there is no file ${TOP_SRC_DIR}/doc/${_cmd}.pdf to copy. Leave it out")
    endif()
    if (EXISTS "${TOP_SRC_DIR}/doc/${_cmd}.html" AND IS_DIRECTORY "${TOP_SRC_DIR}/doc/${_cmd}.html")
      doc_copybin(_depend_gp "${_cmd}.html" "DIR")
      list(APPEND _docs "${_cmd}.html" "${_created}.html")
    else()
      message(STATUS "Sorry, but there is no directory ${TOP_SRC_DIR}/doc/${_cmd}.html to copy. Leave it out")
    endif()
  else()
    # here fig2dev, makeinfo and texi2dvi exist, option DOC set to ON
    #message(STATUS "create ${_created}.info")
    add_custom_command(
      OUTPUT "${_created}.info"
      COMMAND ${MAKEINFO_EXE} "--css-include=${TOP_SRC_DIR}/doc/default.css"
      "-I" "${TOP_SRC_DIR}/doc"
      -o "${_created}.info" "${TOP_SRC_DIR}/doc/${_cmd}.texi"
      DEPENDS "${TOP_SRC_DIR}/doc/${_cmd}.texi"
      ${_${_cmd}_TEXINFOS}
      ${_depend_gp}
      "${CMAKE_CURRENT_BINARY_DIR}/config-h.texi"
      COMMENT "makeinfo: Creating ${_created}.info from ${TOP_SRC_DIR}/doc/${_cmd}.texi"
      )
    install(FILES "${_created}.info" DESTINATION ${DocumentsDirectory})
    add_custom_command(
      OUTPUT "${_created}.texi"
      COMMAND ${CMAKE_COMMAND} -E copy "${TOP_SRC_DIR}/doc/${_cmd}.texi" "${_created}.texi"
      DEPENDS "${TOP_SRC_DIR}/doc/${_cmd}.texi"
      )
    #message(STATUS "${TEXI2DVI_EXE} ${TEXI2DVIFLAGS} --pdf --batch ${_created}.texi")
    file(RELATIVE_PATH _tmp_created "${CMAKE_CURRENT_BINARY_DIR}" "${_created}.texi")
    add_custom_command(
      OUTPUT "${_created}.pdf"
      COMMAND ${TEXI2DVI_EXE} ${TEXI2DVIFLAGS} "--dvipdf" "--batch" "--build=local" "${_tmp_created}"
      DEPENDS "${_created}.texi"
      ${_${_cmd}_TEXINFOS} ${_depend_gp}
      "${CMAKE_CURRENT_BINARY_DIR}/config-h.texi" ${_auxdepends}
      COMMENT "texi2dvi: Creating ${_created}.pdf from ${TOP_SRC_DIR}/doc/${_cmd}.texi, cmdline="${TEXI2DVIFLAGS}
      )
    install(FILES "${_created}.pdf" DESTINATION ${DocumentsDirectory})
    #message(STATUS "create ${_created}.html")
    if(NOSPLIT)
      set(_created_output "${_created}_file.html")
      set(_output_param "${_created}_file.html")
      set(_html_param "--no-split")
    else()
      set(_created_output "${_created}.html/index.html")
      set(_output_param "${_created}.html")
      set(_html_param)
    endif(NOSPLIT)
    add_custom_command(
      OUTPUT "${_created_output}"
      COMMAND ${MAKEINFO_EXE} "--html" ${_html_param} "--css-include=${TOP_SRC_DIR}/doc/default.css"
      "-I" "${TOP_SRC_DIR}/doc"
      -o "${_output_param}" "${TOP_SRC_DIR}/doc/${_cmd}.texi"
      DEPENDS "${TOP_SRC_DIR}/doc/${_cmd}.texi" ${_${_cmd}_TEXINFOS} ${_depend_gp}
      COMMENT "makeinfo: Creating ${_created}.html from ${TOP_SRC_DIR}/doc/${_cmd}.texi"
      )
    if(NOSPLIT)
      install(FILES "${_created}_file.html" DESTINATION ${DocumentsDirectory} RENAME "${_cmd}.html")
    else(NOSPLIT)
      foreach(_img ${_${_cmd}_images})
	set(_needed_image "${_created}.html/${_img}.png")
	set(_parent_image "${CMAKE_CURRENT_BINARY_DIR}/${_img}.png")
	#message(STATUS "_needed_image = ${_needed_image}")
	add_custom_command(
	  OUTPUT "${_needed_image}"
	  COMMAND ${CMAKE_COMMAND} -E copy "${_parent_image}" "${_needed_image}"
	  DEPENDS "${_created}.html/index.html" "${_parent_image}"
	  COMMENT "Copying ${_parent_image} to ${_needed_image}"
	  )
	list(APPEND _docs "${_needed_image}")
      endforeach(_img)
      install(DIRECTORY "${_created}.html" DESTINATION ${DocumentsDirectory})
    endif(NOSPLIT)
    list(APPEND _docs "${_created}.info" "${_created}.pdf" "${_created_output}")
  endif()
endforeach(_cmd)

add_custom_target(doc3 ALL DEPENDS ${_docs})

if(DOC3:BOOL)
  # set make order
  add_dependencies(doc3 doc2 doc1 doc0 enblendenfuse)

=== include/CMakeLists.txt ===

include_directories(${KDE4_INCLUDES} ${KDE4_INCLUDE_DIR} ${QT_INCLUDES} )

add_subdirectory(vigra)
add_subdirectory(vigra_ext)


########### install files ###############




#original Makefile.am contents follow:

#SUBDIRS = vigra vigra_ext

=== src/CMakeLists.txt ===
# This file is part of enblend/enfuse.
# Licence details can be found in the file COPYING.
#
# Copyright (c) 2009-2012, Kornel Benko <Kornel.Benko@berlin.de>
#                   , Ryan Sleevi <ryan+hugin@sleevi.com>
#                   , Harry van der Wolf <hvdwolf@gmail.com>
#

# Get the version-string from ${TOP_SRC_DIR}/VERSION

add_custom_command(
  OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/signature.h"
  COMMAND ${PERL_EXECUTABLE} -I"${TOP_SRC_DIR}/src" "${TOP_SRC_DIR}/src/gen_sig"
  "--extra=${ENBLEND_MAJOR_VERSION}.${ENBLEND_MINOR_VERSION}-${ENBLEND_CHANGESET}"
  ">" "${CMAKE_CURRENT_BINARY_DIR}/signature.h"
  DEPENDS "${TOP_SRC_DIR}/src/gen_sig" "${TOP_SRC_DIR}/VERSION"
  )
set_source_files_properties("${CMAKE_CURRENT_BINARY_DIR}/signature.h" GENERATED)

include_directories(${TOP_SRC_DIR}/src)
#add_subdirectory(vigra_impex)
set(_COMMANDS enblend enfuse)

project(enblendenfuse)
#set(en_libraries vigra_impex ${common_libs})
set(en_libraries ${common_libs})

file(GLOB all_sources ${TOP_SRC_DIR}/src/*.cc)
foreach(_cmd ${_COMMANDS})
  list(REMOVE_ITEM all_sources "${TOP_SRC_DIR}/src/${_cmd}.cc")
endforeach(_cmd)

if (WIN32)
  file(GLOB winhelper_sources ${TOP_SRC_DIR}/src/win32helpers/*.c ${TOP_SRC_DIR}/src/win32helpers/*.h)
  list(APPEND all_sources ${winhelper_sources})
endif(WIN32)

file(GLOB layer_selection ${TOP_SRC_DIR}/src/layer_selection/*.cc ${TOP_SRC_DIR}/src/layer_selection/*.h)
list(APPEND all_sources ${layer_selection})
include_directories(${TOP_SRC_DIR}/src/layer_selection)
list(APPEND all_sources "${CMAKE_CURRENT_BINARY_DIR}/signature.h")
include_directories(${CMAKE_CURRENT_BINARY_DIR})

set(depends2)
message(STATUS "Boost_FOUND = ${Boost_FOUND}")
message(STATUS "OpenMP_CXX_FLAGS = ${OpenMP_CXX_FLAGS}")
foreach(_cmd ${_COMMANDS})
  set(${_cmd}_sources ${all_sources} "${TOP_SRC_DIR}/src/${_cmd}.cc")
  add_executable(${_cmd} ${${_cmd}_sources} )
  #message(STATUS "depends of ${_cmd} ${all_sources}")
  if(OpenMP_CXX_FLAGS AND NOT MSVC)
    set_target_properties(${_cmd} PROPERTIES LINK_FLAGS ${OpenMP_CXX_FLAGS})
    message(STATUS "Adding PROPERTIES LINK_FLAGS to ${_cmd}")
  endif(OpenMP_CXX_FLAGS AND NOT MSVC)
  target_link_libraries(${_cmd} ${en_libraries})
  install(TARGETS ${_cmd} DESTINATION bin CONFIGURATIONS Release RelWithDebInfo MinSizeRel)
  #add_dependencies(${_cmd} vigra_impex)
  list(APPEND depends2 ${_cmd})
endforeach(_cmd)
add_custom_target(enblendenfuse ALL DEPENDS ${depends2})

project(man)
# create enblend.1 and enfuse.1

find_program(HELP2MAN_EXE "help2man")
set(depends3)
foreach (_cmd ${_COMMANDS})
  if (NOT DOC OR ${HELP2MAN_EXE} MATCHES "-NOTFOUND")
    add_custom_command(
      OUTPUT "${_cmd}.1"
      COMMAND ${CMAKE_COMMAND} -E copy "${TOP_SRC_DIR}/src/${_cmd}.1" "${_cmd}.1"
      DEPENDS "${TOP_SRC_DIR}/src/${_cmd}.1"
      )
  else()
    add_custom_command(
      OUTPUT "${_cmd}.1"
      COMMAND "${HELP2MAN_EXE}" "--output=${_cmd}.1" "${CMAKE_BINARY_DIR}/bin/${_cmd}"
      DEPENDS "${CMAKE_BINARY_DIR}/bin/${_cmd}"
      )
  endif()
  list(APPEND depends3 "${CMAKE_CURRENT_BINARY_DIR}/${_cmd}.1")
endforeach(_cmd)
add_custom_target(man ALL DEPENDS ${depends3})
add_dependencies(man enblendenfuse)

=== debian/changelog ===
enblend-enfuse (4.1.2+dfsg-2ubuntu2) trusty; urgency=medium

  * Rebuild for libvigraimpex soname bump.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 22 Feb 2014 14:13:09 +0100

enblend-enfuse (4.1.2+dfsg-2ubuntu1) trusty; urgency=medium

  * Merge from Debian, remaining changes:
    - Build-depend on libglew-dev rather than libglew1.5-dev | libglew1.4-dev
      | libglew-dev.
    - Build using -O1 on arm

 -- Jackson Doak <noskcaj@ubuntu.com>  Wed, 22 Jan 2014 06:23:44 +1100

enblend-enfuse (4.1.2+dfsg-2) unstable; urgency=low

  * Build-Depend on libtiff-dev instead of transitional libtiff4-dev package.
  * Upload to unstable (lcms2 transition).

 -- Andreas Metzler <ametzler@debian.org>  Sun, 29 Dec 2013 13:51:09 +0100

enblend-enfuse (4.1.2+dfsg-1) experimental; urgency=low

  * Use up to date config.sub/config.guess from autotools-dev. (Yes, the files
    in 4.1.1 should be new enough anyway, but we can fix this once and for
    all.)  Closes: #727373
  * Switch b-d to libtiff4-dev as used by vigra-impex.
  * New upstream version 4.1.2.
  * 0001-Change-all-texinfo-variable-names-to-alpha-nums.patch
    0002-expand-homepage-macro.patch
    0003-Texinfo-5.1-workaround-disable-some-macros.patch
    0004-Texinfo-5.1-workaround-macro-on-a-separate-line.patch
    0005-Texinfo-5.1-workaround-macro-on-a-separate-line.patch
    0006-Texinfo-5.1-workaround-macro-on-a-separate-line.patch
    0007-Leave-TEXINPUTS-alone.patch
    0008-Texinfo-5.1-workaround-macro-on-a-separate-line.patch
    0009-Texinfo-5.1-workaround-equationW.patch debian/sed-fix-texi-ids
    Fix build with texinfo 5.1.
  * Point vcs-* to anonscm.debian.org.

 -- Andreas Metzler <ametzler@debian.org>  Sun, 27 Oct 2013 09:27:54 +0100

enblend-enfuse (4.1.1+dfsg-1) experimental; urgency=low

  * New upstream version 4.1.1.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 06 Apr 2013 09:11:35 +0200

enblend-enfuse (4.1+dfsg-1) experimental; urgency=low

  * New upstream version 4.1.
    + unfuzz patches-repack/*
    + Drop unnecessary patches (10_ftbfs-gold.diff,
      11_ftbfs_boost1.46.1.diff)
    + Build depends on liblcms2-dev instead of liblcms1-dev.
      (LP: #885324)
    + Requires external libvigraimpex with OpenEXR support. Closes: #542258
      Since the libvigraimpex is built against libtiff5-dev, enblend also
      switches from 4 to 5.
    + Build-Depends on libgsl0-dev.
    + convert (imagemagick) and xmllint (libxml2-utils) are now required for
      building the documentation.
  * Build with -Wl,--as-needed and default buildflags, using dpkg-buildflags
    --export=configure from dpkg-dev >= 1.16.1.
  * Use debhelper v9.

 -- Andreas Metzler <ametzler@debian.org>  Sun, 13 Jan 2013 17:51:20 +0100

enblend-enfuse (4.0+dfsg-6ubuntu3) trusty; urgency=medium

  * No change rebuild against glew 1.10.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 02 Jan 2014 13:21:09 +0000

enblend-enfuse (4.0+dfsg-6ubuntu2) trusty; urgency=low

  * No change rebuild for Boost 1.54 transition.

 -- Dmitrijs Ledkovs <xnox@ubuntu.com>  Tue, 22 Oct 2013 09:49:20 +0100

enblend-enfuse (4.0+dfsg-6ubuntu1) saucy; urgency=low

  * Merge from Debian, remaining changes:
    - Build-depend on libtiff-dev rather than libtiff4-dev.
    - Build-depend on libglew-dev rather than libglew1.5-dev | libglew1.4-dev
      | libglew-dev.
    - Use default inlining parameters for the build.
    - Build using -O1 on armel.
  
 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Wed, 21 Aug 2013 20:52:52 +0100

enblend-enfuse (4.0+dfsg-6) unstable; urgency=medium

  * 23_perl5.18.diff from upstream HG. - Fix perl 5.18 build failure.
    Closes: #719867

 -- Andreas Metzler <ametzler@debian.org>  Sun, 18 Aug 2013 18:06:11 +0200

enblend-enfuse (4.0+dfsg-5) unstable; urgency=medium

  * Texinfo 5.1 fixes/workarounds:
    + Use only alphanumerical characters in variable names.
      15_texi_ids.diff, 16_hardcodeurl.diff, sed-fix-texi-ids
    + @include file defining VERSION variable before refering to it.
      17_fixinclude.diff.
    + Disable some macros and make sure that macros using conditionals are
      only invoked on a separate line, even if it adds unwanted whitespace.
      18_disablemacros.diff 19_classictimes.diff 20_semilog.diff
      21_inline_foo.diff
    + 22_fixpdfbuild.diff: Stop messing with TEXINPUTS in Makefile*.
    Closes: #708800

 -- Andreas Metzler <ametzler@debian.org>  Sun, 26 May 2013 09:48:16 +0200

enblend-enfuse (4.0+dfsg-4ubuntu4) saucy; urgency=low

  * No change rebuild for Boost 1.53 transition.

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Fri, 26 Apr 2013 19:18:40 +0100

=== debian/control ===
Source: enblend-enfuse
Section: graphics
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
Uploaders: Sebastian Harl <tokkee@debian.org>, Andreas Metzler <ametzler@debian.org>
Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1), autotools-dev,
 libtiff-dev, libboost-dev, libboost-filesystem-dev, liblcms2-dev,
 libglew-dev, freeglut3-dev, libplot-dev,
 zlib1g-dev, libjpeg-dev, libpng12-dev, libopenexr-dev, pkg-config, help2man,
 perl, texinfo, texlive, texlive-generic-recommended, gnuplot, transfig,
 ghostscript, tidy, ttf-freefont,imagemagick, libxml2-utils,
 libvigraimpex-dev (>= 1.8.0+dfsg-2), libgsl0-dev
Standards-Version: 3.9.5
Homepage: http://enblend.sourceforge.net/
Vcs-Git: git://anonscm.debian.org/pkg-phototools/enblend.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-phototools/enblend.git

Package: enblend
Architecture: any
Depends: ${shlibs:Depends},${misc:Depends}
Recommends: hugin
Enhances: hugin
Description: image blending tool
 Enblend is a tool for compositing images. Given a set of images that overlap
 in some irregular way, Enblend overlays them in such a way that the seam
 between the images is invisible, or at least very difficult to see. It can,
 for example, be used to blend a panorama composed of several images.
 .
 It uses a Burt & Adelson multi-resolution spline. This technique tries to
 make the seams between the input images invisible. The basic idea is that
 image features should be blended across a transition zone proportional in
 size to the spatial frequency of the features. For example, objects like
 trees and windowpanes have rapid changes in color. By blending these
 features in a narrow zone, you will not be able to see the seam because the
 eye already expects to see color changes at the edge of these features.
 Clouds and sky are the opposite. These features have to be blended across a
 wide transition zone because any sudden change in color will be immediately
 noticeable.
 .
 Enblend does not align images for you. Use a tool like Hugin or PanoTools to
 do this. The TIFFs produced by these programs are exactly what Enblend is
 designed to work with.

Package: enfuse
Architecture: any
Depends: ${shlibs:Depends},${misc:Depends}
Recommends: hugin
Enhances: hugin
Description: image exposure blending tool
 Enfuse blends differently exposed images of the same scene into a nice output
 image, without producing intermediate HDR images that are then tonemapped to a
 viewable image. This simplified process often works much better and quicker
 than the currently known tonemapping algorithms.
 .
 The exposure blending is done using the Mertens-Kautz-Van Reeth exposure
 fusion algorithm. The basic idea is that pixels in the input images are
 weighted according to qualities such as proper exposure, good contrast, and
 high saturation. These weights determine how much a given pixel will
 contribute to the final image.
 .
 Enfuse does not align images for you. Use a tool like Hugin or PanoTools to do
 this. The TIFFs produced by these programs are exactly what Enfuse is designed
 to work with.

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for enblend-enfuse
#
# Written by Sebastian Harl <sh@tokkee.org>.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)

ifeq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
    ifneq (,$(findstring arm,$(DEB_HOST_GNU_TYPE)))
        export DEB_CFLAGS_MAINT_STRIP = -O2
        export DEB_CXXFLAGS_MAINT_STRIP = -O2
        export DEB_CFLAGS_MAINT_APPEND = -O1
        export DEB_CXXFLAGS_MAINT_APPEND = -O1
    endif
endif

CONFARGS=--host=$(DEB_HOST_GNU_TYPE) \
		--build=$(DEB_BUILD_GNU_TYPE) \
		$(shell env DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed \
		dpkg-buildflags --export=configure) \
		--prefix=/usr --mandir=\$${prefix}/share/man \
		--enable-gpu-support=yes \
		--with-boost-filesystem=yes \
		--with-openexr=yes

#		--disable-openmp \
#		--enable-image-cache=yes \


get-orig-source:
	dh_testdir
	dh_testroot
	chmod 755 debian/bin/uscan_repack.sh
	uscan --verbose --force-download --rename

# Hack: Since out of tree building of documentation is broken, make a out-tree
# build for mp versions and in-tree build for the regular binaries. Out of tree
# configure fails if in-tree configure run is detected, therefore force correct
# ordering by making config.status depend on build-tree-mp/config.status.
config.status: configure build-tree-mp/config.status
	dh_testdir
	./configure $(CONFARGS) \
		--disable-openmp \
		--enable-image-cache=yes

build-tree-mp/config.status: configure
	dh_testdir
	rm -vf config.guess config.sub
	ln -s /usr/share/misc/config.sub /usr/share/misc/config.guess .
	if ! test -e build-tree-mp ; then mkdir build-tree-mp ; fi
	cd build-tree-mp && ../configure $(CONFARGS) \
		--enable-openmp \
		--disable-image-cache

build-indep:
	# nothing to do

build-arch: build-arch-stamp

build: build-arch-stamp

build-arch-stamp: config.status build-tree-mp/config.status
	dh_testdir
	
	cd build-tree-mp && $(MAKE)
	$(MAKE)
	
	$(MAKE) pdf
	
	sed -e "s/manual page for enblend.*/combine images using a multiresolution spline/" \
		src/enblend.1 > src/enblend.1.tmp
	mv src/enblend.1.tmp src/enblend.1
	sed -e "s/manual page for enfuse.*/poor man's HDR/" \
		src/enfuse.1 > src/enfuse.1.tmp
	mv src/enfuse.1.tmp src/enfuse.1
	
	touch build-arch-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-arch-stamp
	
	[ ! -f Makefile ] || $(MAKE) distclean
	rm -f doc/*.info doc/enblend.tpt doc/enfuse.tpt
	rm -rf build-tree-mp
	rm -vf config.guess config.sub
	
	dh_clean

install: build-arch-stamp
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	
	$(MAKE) DESTDIR=$(CURDIR)/debian/tmp install
	rm -f $(CURDIR)/debian/tmp/usr/share/info/dir
	install -m755  build-tree-mp/src/enblend \
		$(CURDIR)/debian/tmp/usr/bin/enblend-mp
	install -m755  build-tree-mp/src/enfuse \
		$(CURDIR)/debian/tmp/usr/bin/enfuse-mp

binary-indep:
	# nothing to do here

binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs -a ChangeLog
	dh_installdocs -A -a NEWS AUTHORS
	dh_installexamples -a
	dh_install -a --sourcedir=debian/tmp --fail-missing
	dh_installman -a
	dh_installinfo -penblend doc/enblend.info
	dh_installinfo -penfuse doc/enfuse*.info
	dh_link -a
	dh_strip -a
	dh_compress -a -X.pdf
	dh_fixperms -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep binary-arch
.PHONY: get-orig-source build clean binary-indep binary-arch binary install build-arch build-indep

=== debian/watch ===
version=3

opts=dversionmangle=s/\+dfsg$// \
http://sf.net/enblend/enblend(?:-enfuse)?-([0-9.]+)\.tar\.gz \
	debian debian/bin/uscan_repack.sh

## enblend-enfuse 4.1.3+dfsg

=== debian/changelog ===
enblend-enfuse (4.1.3+dfsg-2) unstable; urgency=medium

  * Upload to unstable.

 -- Andreas Metzler <ametzler@debian.org>  Tue, 22 Jul 2014 08:21:27 +0200

enblend-enfuse (4.1.3+dfsg-1) experimental; urgency=low

  [ Andreas Metzler ]
  * Build with -pipe.
  * Update uscan_repack.sh to use xz compression.
  * New upstream version.
    + Refresh 0001-Change-all-texinfo-variable-names-to-alpha-nums.patch.
    + Versioned build-dependency on liblcms2-dev >= 2.5.

  [ Jackson Doak ]
  * Swap build-depend on libglew1.5-dev | libglew1.4-dev | libglew-dev
    to libglew-dev. The other two are deprecated.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 22 Mar 2014 15:17:26 +0100

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,10 @@
 Source: enblend-enfuse
 Section: graphics
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
+Maintainer: Debian PhotoTools Maintainers <pkg-phototools-devel@lists.alioth.debian.org>
 Uploaders: Sebastian Harl <tokkee@debian.org>, Andreas Metzler <ametzler@debian.org>
 Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1), autotools-dev,
- libtiff-dev, libboost-dev, libboost-filesystem-dev, liblcms2-dev,
+ libtiff-dev, libboost-dev, libboost-filesystem-dev, liblcms2-dev (>= 2.5),
  libglew-dev, freeglut3-dev, libplot-dev,
  zlib1g-dev, libjpeg-dev, libpng12-dev, libopenexr-dev, pkg-config, help2man,
  perl, texinfo, texlive, texlive-generic-recommended, gnuplot, transfig,

=== debian/rules ===
--- 
+++ 
@@ -11,18 +11,11 @@
 DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
 
-ifeq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
-    ifneq (,$(findstring arm,$(DEB_HOST_GNU_TYPE)))
-        export DEB_CFLAGS_MAINT_STRIP = -O2
-        export DEB_CXXFLAGS_MAINT_STRIP = -O2
-        export DEB_CFLAGS_MAINT_APPEND = -O1
-        export DEB_CXXFLAGS_MAINT_APPEND = -O1
-    endif
-endif
-
 CONFARGS=--host=$(DEB_HOST_GNU_TYPE) \
 		--build=$(DEB_BUILD_GNU_TYPE) \
-		$(shell env DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed \
+		$(shell env DEB_CFLAGS_MAINT_APPEND=-Wall \
+		DEB_CXXFLAGS_MAINT_APPEND=-pipe \
+		DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed \
 		dpkg-buildflags --export=configure) \
 		--prefix=/usr --mandir=\$${prefix}/share/man \
 		--enable-gpu-support=yes \

## enblend-enfuse 4.1.4%2Bdfsg

=== doc/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 # This file is part of enblend.
 # Licence details can be found in the file COPYING.
 #
-# Copyright (c) 2009-2012, Kornel Benko <Kornel.Benko@berlin.de>
+# Copyright (c) 2009-2015, Kornel Benko <Kornel.Benko@berlin.de>
 #
 
 include(GetPrerequisites)	# get function gp_append_unique()

## enblend-enfuse 4.1.4+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 # This file is part of enblend/enfuse.
 # Licence details can be found in the file COPYING.
 #
-# Copyright(c) 2009-2010, Kornel Benko <Kornel.Benko@berlin.de>
+# Copyright(c) 2009-2015, Kornel Benko <Kornel.Benko@berlin.de>
 #                  , Ryan Sleevi <ryan+hugin@sleevi.com>
 #                  , Harry van der Wolf <hvdwolf@gmail.com>
 # Original file from lyx-project, heavily modified

=== debian/changelog ===
enblend-enfuse (4.1.4+dfsg-5) unstable; urgency=medium

  * Move Vcs-* from git/http to https.
  * Pull
    31_467a73754dbb_Fix_issue__1537368__Unconditional_usage_of_std__auto_ptr__.diff
    from upstream HG (4.1.5 branch), which should allow building with g++6.
    Untested though, since boost and g++6 are not co-installable currently.
    Closes: #811869

 -- Andreas Metzler <ametzler@debian.org>  Thu, 28 Jan 2016 19:34:42 +0100

enblend-enfuse (4.1.4+dfsg-4) unstable; urgency=medium

  * Build-Depend on libpng-dev instead of libpng12-dev, 4.1.4 builds
    successfully against libpng 1.6. Closes: #662314

 -- Andreas Metzler <ametzler@debian.org>  Wed, 06 Jan 2016 14:50:28 +0100

enblend-enfuse (4.1.4+dfsg-3) unstable; urgency=medium

  * Build-Depend on libgsl-dev instead of libgsl0-dev. Closes: #806830

 -- Andreas Metzler <ametzler@debian.org>  Thu, 03 Dec 2015 19:24:40 +0100

enblend-enfuse (4.1.4+dfsg-2) unstable; urgency=low

  * 20_reproducible_sig.diff: Use timestamp et al. from debian/changelog
    instead of current time/user/host for binary signature generation.
  * Upload to unstable.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 10 Oct 2015 14:11:52 +0200

enblend-enfuse (4.1.4+dfsg-1) experimental; urgency=medium

  * New upstream version.
    + Refresh patches-repack/00-win32helpers.patch.
    + Drop debian/patches/*, upstream docs are compatible with texinfo
      5.1 now.

 -- Andreas Metzler <ametzler@debian.org>  Sat, 03 Oct 2015 14:02:14 +0200

=== debian/control ===
--- 
+++ 
@@ -6,18 +6,18 @@
 Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1), autotools-dev,
  libtiff-dev, libboost-dev, libboost-filesystem-dev, liblcms2-dev (>= 2.5),
  libglew-dev, freeglut3-dev, libplot-dev,
- zlib1g-dev, libjpeg-dev, libpng12-dev, libopenexr-dev, pkg-config, help2man,
+ zlib1g-dev, libjpeg-dev, libpng-dev, libopenexr-dev, pkg-config, help2man,
  perl, texinfo, texlive, texlive-generic-recommended, gnuplot, transfig,
  ghostscript, tidy, ttf-freefont,imagemagick, libxml2-utils,
- libvigraimpex-dev (>= 1.8.0+dfsg-2), libgsl0-dev
-Standards-Version: 3.9.5
+ libvigraimpex-dev (>= 1.8.0+dfsg-2), libgsl-dev
+Standards-Version: 3.9.6
 Homepage: http://enblend.sourceforge.net/
-Vcs-Git: git://anonscm.debian.org/pkg-phototools/enblend.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-phototools/enblend.git
+Vcs-Git: https://anonscm.debian.org/git/pkg-phototools/enblend.git
+Vcs-Browser: https://anonscm.debian.org/cgit/pkg-phototools/enblend.git
 
 Package: enblend
 Architecture: any
-Depends: ${shlibs:Depends},${misc:Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}
 Recommends: hugin
 Enhances: hugin
 Description: image blending tool

=== debian/rules ===
--- 
+++ 
@@ -10,6 +10,8 @@
 # from having to guess our platform (since we know it already)
 DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
+#used by  debian/patches/20_reproducible_sig.diff
+export DEB_TOP_DIR:=$(CURDIR)
 
 CONFARGS=--host=$(DEB_HOST_GNU_TYPE) \
 		--build=$(DEB_BUILD_GNU_TYPE) \
